# This files contains your custom actions which can be used to run
# custom Python code.
#
# See this guide on how to implement these action:
# https://rasa.com/docs/rasa/custom-actions


# This is a simple example for a custom action which utters "Hello World!"
from typing import Any, Text, Dict, List

from rasa_sdk import Action, Tracker
from rasa_sdk.executor import CollectingDispatcher
import requests
import json

respuestas = {}


class ActionHelloWorld(Action):

	def name(self) -> Text:
		return "action_hello_world"
	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		data = {'sender':'','message':'bye'}
		json_dump = json.dumps(data) 		
		r = requests.post("http://localhost:8080/webhooks/rest/webhook", json_dump) 
		dispatcher.utter_message(text="Se ejecuto accion hello world: {}!".format(r.text))
	
		return []


class ActionOnlineMembers(Action):

	def name(self) -> Text:
		return "action_online_members"

	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		f = open('online.json',) 
		dataOnline = json.load(f) 
		rta = ""
		for i in dataOnline['online']:
			#print("{} se encuentra en {}".format(i['name'], i['sala']))        
			rta += "{} se encuentra en {} \n".format(i['name'], i['sala'])
		#dispatcher.utter_message(text="Se ejecuto accion online members: {}!".format(r.text))
		dispatcher.utter_message(text=rta)
		return []



class ActionTareasToDo(Action):

	def name(self) -> Text:
		return "action_tareas_to_do"

	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		f = open('tareas.json',) 
		dataOnline = json.load(f)
		rta = ""
		rta += "Las tareas en estado to do son:\n"
		for i in dataOnline['to_do']:       
			rta+="--Tarea: {}. Nombre {}.\n Descripcion: {}.\n Criterios de aceptacion: {}\n".format(i['id_tarea'],i['nombre'], i['descripcion'], i['criterios de aceptacion'])
		rta += "\nQuieres asignarte alguna tarea?"
		dispatcher.utter_message(text=rta)
		return []

class ActionTareasInProgress(Action):

	def name(self) -> Text:
		return "action_tareas_in_progress"

	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		f = open('tareas.json',)
		dataOnline = json.load(f)
		rta = ""
		rta += "Las tareas en estado in progress son:\n"
		for i in dataOnline['in_progress']:     
			rta+="--Tarea: {}. Nombre {}.\n Descripcion: {}.\n Criterios de aceptacion: {}\n Participantes: {}\n".format(i['id_tarea'],i['nombre'], i['descripcion'], i['criterios de aceptacion'],i['participantes'])
		dispatcher.utter_message(text=rta)
		return []

class ActionTareasDone(Action):

	def name(self) -> Text:
		return "action_tareas_done"

	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		f = open('tareas.json',) 
		dataOnline = json.load(f)
		rta = ""
		rta += "Las tareas en estado done son:\n"
		for i in dataOnline['done']:
			rta+="--Tarea: {}. Nombre {}.\n Descripcion: {}.\n Criterios de aceptacion: {}\n".format(i['id_tarea'],i['nombre'], i['descripcion'], i['criterios de aceptacion'])
		dispatcher.utter_message(text=rta)
		return []


class ActionOrganizacionActual(Action):

	def name(self) -> Text:
		return "action_organizacion_actual"

	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		f = open('organizacion.json',) 
		dataOnline = json.load(f) 
		dataOnline = dataOnline['sprint']
		rta = ""
		rta += "En el sprint {}, las tareas estan organizadas segun los siguientes grupos:\n".format(dataOnline['numero'])
		for i in dataOnline['equipos']:
			rta += "--Grupo: {}. Cuyo lider es: {}".format(i['grupo'], i['lider'])
		dispatcher.utter_message(text=rta)
		return []


class ActionMiTarea(Action):

	def name(self) -> Text:
		return "action_mi_tarea"

	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		f = open('tareas.json',)
		dataOnline = json.load(f)
		#dispatcher.utter_message(text=tracker.sender_id)
		asignada = False
		user = "Mercedes"  #Alguna forma de obtener el id del usuario
		for i in dataOnline['in_progress']:
			if (user in i['participantes']):
				dispatcher.utter_message(text="Tienes la tarea {} asignada para hoy.".format(i['nombre']))
				asignada = True
		if(asignada == False):
			dispatcher.utter_message(text="No tienes ninguna tarea asignada, debes revisar las tareas en estado to do y tomar una")
		return []


class ActionAsignarTarea(Action):

	def name(self) -> Text:
		return "action_asignar_tarea"

	def run(self, dispatcher: CollectingDispatcher,
	tracker: Tracker,
	domain: Dict[Text, Any]) -> List[Dict[Text, Any]]:
		f = open('tareas.json',)
		dataOnline = json.load(f)
		nombre= ''
		descrip = ''
		criterios = []
		participantes = ['Mercedes']
		id = 0
		for word in tracker.latest_message.get('text').split():
			if word.isdigit():
				id = int(word)
				break
		aux = dataOnline['to_do']
		for i in aux:
			if (i['id_tarea'] == id):
				nombre = i['nombre']
				descrip = i['descripcion']
				criterios = i['criterios de aceptacion']
				dataOnline['to_do'].remove(i)
				break
		if (nombre != ''):
			dataOnline['in_progress'].append({
				'id_tarea':id,
				'nombre':nombre,
				'descripcion':descrip,
				'criterios de aceptacion':criterios,
				'participantes':participantes
			})
			dispatcher.utter_message(text='La tarea con id: {} fue correctamente asignada'.format(id))
		else:
			dispatcher.utter_message(text='No hay una tarea con ese id')	
		with open('tareas.json', 'w') as outfile:
			json.dump(dataOnline, outfile)
		return []





