// install:
// npm install websocket
// run:
// node test.js

// evaluating libs with vars in current context instead of 'require'



const axios = require('axios');
var util = require('util')
var vm = require("vm");
var fs = require("fs");
var load = function(path, context) {
  var data = fs.readFileSync(path);
  vm.runInThisContext(data, path);
}

var WebSocketClient = require("websocket").client

// adapter for browser websocket
WebSocket = function (uri) {
	console.info("============", uri);
	var self = this;
	this.connection = null;
	this.socket = new WebSocketClient();
	this.socket.on('connectFailed', function (errorDescription) {
		self.onerror(errorDescription);
	})
	this.socket.on('connect', function (connection) {
		console.info("============");
		self.connection = connection;

		connection.on('error', function (error) {
			console.info("WS error:", error);
			self.onerror(error);
		});

		connection.on('close', function (ev) {
			console.info("WS close:", ev);
			self.onclose(ev);
		});

		connection.on('message', function (message) {
//			console.info("WS message:", message);
			if (message.type === 'utf8') {
				self.onmessage({data:message.utf8Data});
			}
			return true;
		});

		self.onopen();
	});
	this.socket.connect(uri);
}

WebSocket.prototype.send = function (data) {
	if(this.connection)
		this.connection.sendUTF(data);
}

WebSocket.prototype.close = function () {
	if(this.connection)
		this.connection.close();
}
///////

load("./Photon/Photon-Javascript_SDK.js")

var AppInfo = {
    //MasterAddress: "app-eu.exitgamescloud.com:9090",
    //AppId: "bbf8e977-e45d-47e5-b417-edcefc119f17",
    AppIdChat: "236c4fc6-a76a-45dd-8e43-9f5144e82664",
    AppVersion: "1.0_2.22",
}

var ChatClient = Photon.Chat.ChatClient;
var cc = new ChatClient(Photon.ConnectionProtocol.Ws, AppInfo.AppIdChat, AppInfo.AppVersion);
cc.setUserId("Chatbot");

cc.onChatMessages = function(channelName, messages) {
    console.log("onChatMessages holita");
    console.log(channelName);
    console.log(messages);


    for (var i in messages) {
        var m = messages[i];
        var sender = m.getSender();
        if (sender == this.getUserId()) {
            sender = "me";
        }
        var indexArroba = m.getContent().indexOf("#chatbot");
        if (indexArroba != -1){
            /*const userAction = async () => {
                const response = await fetch('http://localhost:5005/webhooks/rest/webhook', {
                method: 'POST',
                body: JSON.stringify({'sender':m.getSender,'message':m.getContent()}) // string or object
                });
                const myJson = await response.json(); //extract JSON from the http response
                // do something with myJson
                //Output.log('[' + channelName + ': Chatbot ]', myJson[0]['text']);
                this.publishMessage('test', myJson[0]['text'])
            }*/
            const userAction = async () => {
                try {
                    const res = await axios.post('http://localhost:5005/webhooks/rest/webhook', JSON.stringify({'sender':m.getSender,'message':m.getContent().replace("#chatbot","")}));
                    this.publishMessage('test', res.data[0].text);
                } catch (err) {
                    console.error(err);
                }
            };
            userAction();
        }
        console.log('[' + channelName + ':' + sender + ']', m.getContent().substring(indexArroba, m.getContent().length));
    }



}

cc.onSubscribeResult = function (results) {
    console.log("onSubscribeResult holita");
    console.log(results);
}

cc.onStateChange = function(state) {    
    if(state == Photon.Chat.ChatClient.ChatState.ConnectedToFrontEnd){
        console.log("llamando a subscribe");
        cc.subscribe(["test"]);
    }
}

cc.connectToRegionFrontEnd("EU");
cc.subscribe("test")



 


