﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class PanelTareaPersonalizada : MonoBehaviour
{
     private GameObject[] nombres;
     public List<CampoTarea> campos = new List<CampoTarea>();
     public GameObject PrefabCampo;
     private GameObject Campo;
  
  

    public void Awake()
    {
        campos = (GameObject.FindGameObjectWithTag("TareaPersonalizada")).GetComponent<TareaPersonalizada>().campos;
        nombres = new GameObject[8];
    }

    public void Show()
    {
        if (PrefabCampo != null)
        {
            for (int i = 0; i < campos.Count; i++)
                CrearCampo(i);
        }
        else
        {
            gameObject.SetActive(true);
        }
    }

    public void CrearCampo(int i){
         Campo = Instantiate(PrefabCampo, new Vector3(0,0,0),transform.rotation) as GameObject;
         Campo.transform.SetParent(gameObject.transform,false);
         nombres[i] = Campo.transform.Find("Nombre").gameObject;
         nombres[i].transform.position = gameObject.transform.position + new Vector3(-getWidth(nombres[i])/2, getHeight(gameObject)/2 - getHeight(nombres[i]) -20 - i*getHeight(nombres[i]) , 0);
         nombres[i].GetComponent<Text>().text = campos[i].nombre;
     }
  

    public void AgregarCampo()
    {
        if(campos.Count < 9)
        {
            CrearCampo(campos.Count-1);
        }
    }

    public int getWidth(GameObject go)
    {
        return (int) (go.transform.GetComponent<RectTransform>().rect.width);
    }

    public int getHeight(GameObject go)
    {
        return (int) (go.transform.GetComponent<RectTransform>().rect.height);
    }

}
