﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Reflection;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;
using UnityEngine.UIElements;

public struct CampoTarea
{
    public string nombre;
    public string descripcion;
    public int tamaño;
}

public class Tarea : MonoBehaviour//, IPointerDownHandler, IBeginDragHandler, IEndDragHandler, IDragHandler
{
    private Sprite b1;
    public GameObject PrefabPanelTarea;
    private GameObject PanelTarea;
    private List<Text> nombres = new List<Text>();
    private TareaPersonalizada TareaPersonalizada;
    private RectTransform rectTransform;
    private UnityEngine.UI.Button buttonChange;
    public List<CampoTarea> campos;

    void Start()
    {
        campos = new List<CampoTarea>((GameObject.FindGameObjectWithTag("TareaPersonalizada")).GetComponent<TareaPersonalizada>().campos);
    }

    //PARA MOVER LA TAREA, LO COMENTO TODO POR AHORA
    /*private void Awake()
    {
        rectTransform = GetComponent<RectTransform>();
    }

    public void OnPointerDown(PointerEventData eventData)
    {
        Debug.Log("OnPointerDown");
    }

    public void OnBeginDrag(PointerEventData eventData)
    {
        Debug.Log("OnBeginDrag");
    }

    public void OnEndDrag(PointerEventData eventData)
    {
        Debug.Log("OnEndDrag");
    }

    public void OnDrag(PointerEventData eventData)
    {
        Debug.Log("OnDrag");
        rectTransform.anchoredPosition += eventData.delta;
    }*/
 
    public void PanelTareaOpener()
    {
        if (PanelTarea != null)
        {
            PanelTarea.SetActive(true);
        }
        else
        {
            PanelTarea = Instantiate(PrefabPanelTarea,transform.position,transform.rotation) as GameObject; 
            PanelTarea.transform.SetParent(gameObject.transform,false);
            PanelTarea.GetComponent<PanelTarea>().campos = campos;
            PanelTarea.transform.position = GameObject.FindGameObjectWithTag("Canvas").transform.position;
            /*
            GameObject BotonCerrar = PanelTarea.transform.Find("Cerrar").gameObject;
            GameObject InputField = PanelTarea.transform.Find("CampoAAgregar").gameObject;
            GameObject BotonAgregarCampo = PanelTarea.transform.Find("BotonAgregarCampoEspecifico").gameObject;
            InputField.transform.position = PanelTarea.transform.position + new Vector3(getWidth(PanelTarea)/2 - getWidth(InputField)/2-10, -getHeight(PanelTarea)/2 + getHeight(InputField)/2  + 10 ,0);
            BotonAgregarCampo.transform.position = InputField.transform.position + new Vector3(-getWidth(InputField),0,0);
            BotonCerrar.transform.position = PanelTarea.transform.position + new Vector3(getWidth(PanelTarea)/2 - getWidth(BotonCerrar)/2 -10, getHeight(PanelTarea)/2 - getHeight(BotonCerrar)/2  - 10 ,0);
            */

            PanelTarea.gameObject.GetComponent<PanelTarea>().Show();
        }
    }

    public void AddCampo(string nombre)
    {
        CampoTarea campo;
        campo.nombre = nombre;
        campo.descripcion = "";
        campo.tamaño = 100;
        campos.Add(campo);
    }

    public int getWidth(GameObject go)
    {
        return (int) (go.transform.GetComponent<RectTransform>().rect.width);
    }

    public int getHeight(GameObject go)
    {
        return (int) (go.transform.GetComponent<RectTransform>().rect.height);
    }
}